
-- return the window size
getWindowSize = getWindowSize or function()
	return 400, 400
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()
	setBannerContent( "nameOnly", 20, 140 )

	-- constants
	local kSpace = 19
	local kKnobSpace = kKnobSize + kSpace
	local kKnobSpaceV = 70
	local kPropertyTextFieldH = 20
	local kLabelSpaceV = 30
	local kTextW = 40
	local kDropdownW = 70
	local kGraphW = 150
	local kGraphH = 150

	local function knobGroup( LR, title, id )
		g = group( title )
		local x = 0
		local y = 0
		
		labelledDropDown( g, "Function " .. LR,					"Function",				x, y, kDropdownW )
		y = y + kKnobSpaceV
		g:add( paramButton( "Enable " .. LR,					"Enable",				x, y, 50, 30 ) )
		x = x + kDropdownW + pad
		y = 0
		smallKnobAndTextField( g, "Input Offset " .. LR,		"Offset",				x, y, kTextW )
		y = y + kKnobSpaceV
		smallKnobAndTextField( g, "Input Scale " .. LR,			"Scale",				x, y, kTextW )
		x = x + kKnobSpace
		y = 0
		local ed = functionDisplay( id, x, y-15, kGraphW, kGraphH )
		setFunctionDisplayColours( ed )
		g:add( ed )
		x = x + kGraphW + pad
		smallKnobAndTextField( g, "Output Offset " .. LR,		"Offset",				x, y, kTextW )
		y = y + kKnobSpaceV
		smallKnobAndTextField( g, "Output Scale " .. LR,		"Scale",				x, y, kTextW )
		x = x + kKnobSpace

		return g
	end

	-- make groups and knobs
	--

	theKnobRenderer = smallKnobRenderer

	miscGroup = group( "OSC" )
	smallKnobAndTextField( miscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	miscGroup:setVisible( false )

	leftGroup = knobGroup( "L", "Left Channel", 0 )
	rightGroup = knobGroup( "R", "Right Channel", 1 )

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase
	
	rightGroup:setPosition( x, y, true )
	x = x + rightGroup:width() + pad
	
	miscGroup:setPosition( x, y, true )
	x = x + miscGroup:width() + pad
	
	x = xbase
	y = y + rightGroup:height() + pad
	
	leftGroup:setPosition( x, y, true )
	x = x + leftGroup:width() + pad
	
	local prefsX = x
	local prefsY = y

	-- add directly positioned objects
	--

	-- add the prefs button
	
	local kPrefsW = 60
	y = prefsY + 40

end		-- of createUI()
