
-- return the window size
getWindowSize = getWindowSize or function()
	return 733, 360
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()

	-- constants
	local kKnobSpace = 45
	local kBigKnobSpace = 101
	local kKnobSpaceV = 70
	local kWaveformW = 100
	local kWaveformH = 100
	local kDropdownW = 65
	local kTextW = 40
	
	local function knobGroup( LR, id, title )
		g = group( title )
		
		local x = 0
		local y = 0

		theKnobRenderer = bigKnobRenderer

		bigKnobAndTextField( g, "Speed " .. LR,		"Speed",			x, y )
		x = x + kBigKnobSpace

		local kLabelSpaceV = 30
		labelledDropDown( g, "Speed Multiplier " .. LR, "Multiplier", x, y, kDropdownW )
		y = y + 1.4*kLabelSpaceV
		labelledDropDown( g, "Sync " .. LR, "Sync", x, y, kDropdownW )
		y = y + kLabelSpaceV
		labelledDropDown( g, "Beat Divisor " .. LR, "Divisor", x, y, kDropdownW )
		y = y + kTextFieldH + 4
		g:add( paramButton( "Triplet " .. LR, "Triplet", x, y, kDropdownW, kTextFieldH ) )
		y = y + kTextFieldH + 4
		g:add( paramButton( "Reset By Note " .. LR, "Reset", x, y, kDropdownW, kTextFieldH ) )
		
		x = x + kDropdownW + pad
		y = 0

		bigKnobAndTextField( g, "Beats " .. LR,		"Beats",			x, y )
		x = x + kBigKnobSpace

		theKnobRenderer = smallKnobRenderer

		local x1 = x
		
		smallKnobAndTextField( g, "Phase " .. LR,			"Phase",	x, y )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Offset " .. LR,			"Offset",	x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Asymmetry " .. LR,		"Asym",		x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Pulse Width " .. LR,		"PW",		x, y )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Smoothing " .. LR,		"Smooth",	x, y )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Swing " .. LR,			"Swing",	x, y )
		x = x + kKnobSpace
		labelledDropDown( g, "Swing Type " .. LR, "Swing", x, y, 35 )
		x = x + 35 + pad
		labelledDropDown( g, "Input Mode " .. LR, "Input Mode", x, y )

		x = x1
		y = y + kKnobSpaceV

		smallKnobAndTextField( g, "Sine " .. LR,			"Sine",		x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Triangle " .. LR,		"Triangle",	x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Saw " .. LR,				"Saw",		x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Square " .. LR,			"Square",	x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Random " .. LR,			"Random",	x, y )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Noise " .. LR,			"Noise",	x, y )
		x = x + kKnobSpace

		y = 15
		local wv = waveformDisplay( id, x, y, kWaveformW, kWaveformH )
		setWaveformDisplayColours( wv )
		g:add( wv )

		return g
	end

	-- make groups and knobs
	--

	theKnobRenderer = smallKnobRenderer

	miscGroup = group( "OSC" )
	smallKnobAndTextField( miscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	miscGroup:setVisible( false )

	leftGroup = knobGroup( "L", 0, "Left Channel" )
	rightGroup = knobGroup( "R", 1, "Right Channel" )

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase
	
	rightGroup:setPosition( x, y, true )
	x = x + rightGroup:width() + pad

	local prefsX = x
	
	miscGroup:setPosition( x, y, true )
	x = x + miscGroup:width() + pad
	
	x = xbase
	y = y + rightGroup:height() + pad
	
	leftGroup:setPosition( x, y, true )
	x = x + leftGroup:width() + pad
	
	local prefsY = y + pad

	-- add directly positioned objects
	--

end		-- of createUI()
